' Kleines Apfelmnnchen

TYPE Komplex
	r AS SINGLE
	i AS SINGLE
END TYPE

DECLARE SUB AddiereKomplex (a AS Komplex, b AS Komplex, s AS Komplex)
DECLARE SUB Multipliziere (a AS Komplex, b AS Komplex, p AS Komplex)
DECLARE FUNCTION KomplexABS2! (a AS Komplex)
DECLARE SUB ZeichneXORRechteck (x1%, y1%, x2%, y2%)
DECLARE SUB ZeichneFadenkreuz (x%, y%)

' $INCLUDE: 'QB.BI'

DIM SHARED xorRecht%(961)
DIM z0 AS Komplex, z AS Komplex, c AS Komplex, t AS Komplex
DIM dosIntEin AS RegType, dosIntAus AS RegType

FOR i% = 0 TO 961
	xorRecht%(i%) = -1
NEXT i%

INPUT "Rechentiefe"; rMax%
INPUT "Konstante z0 (Real, Imaginr)"; z0.r, z0.i
' Initialausschnitt automatisch berechnen
Multipliziere z0, z0, t
xMin! = -2.8 - t.r
xMax! = 2.8 - t.r
yMax! = 2.1 - t.i

SCREEN 12
dosIntEin.ax = &H0
CALL INTERRUPT(&H33, dosIntEin, dosIntAus)
IF dosIntAus.ax <> &HFFFF THEN
	SCREEN 0
	PRINT "Keine Maus fr Zoom vorhanden!"
	END
END IF

drinbleib% = -1
WHILE drinbleib%
	fakt! = (xMax! - xMin!) / 640!
	FOR y% = 0 TO 479
		c.i = yMax! - CSNG(y%) * fakt!
		FOR x% = 0 TO 639
			c.r = xMin! + CSNG(x%) * fakt!
			z = z0
			r% = 0
			WHILE r% < rMax% AND KomplexABS2(z) < 4!
				' Formel z(i+1)=z(i)^2+c
				Multipliziere z, z, t
				AddiereKomplex t, c, z
				r% = r% + 1
			WEND
			IF r% = rMax% THEN
				PSET (x%, y%), 0
			ELSE
				PSET (x%, y%), 1 + r% MOD 15
			END IF
		NEXT x%
	NEXT y%
	' Zoom ermglichen
	' 1. Ecke
	LOCATE 1, 1
	PRINT "1. Ecke:"
	xAlt% = 320
	yAlt% = 240
	ZeichneFadenkreuz xAlt%, yAlt%
	DO
		dosIntEin.ax = &H3
		CALL INTERRUPT(&H33, dosIntEin, dosIntAus)
		x1% = dosIntAus.cx
		y1% = dosIntAus.dx
		IF x1% <> xAlt% OR y1% <> yAlt% THEN
			ZeichneFadenkreuz xAlt%, yAlt%
			ZeichneFadenkreuz x1%, y1%
			xAlt% = x1%
			yAlt% = y1%
		END IF
		ta$ = INKEY$
		IF ta$ = CHR$(27) THEN
			drinbleib% = 0
		END IF
	LOOP WHILE (dosIntAus.bx AND 1) = 0 AND drinbleib%
	ZeichneFadenkreuz x1%, y1%
	' 2. Ecke
	LOCATE 1, 1
	PRINT "2. Ecke:"
	x2% = x1%
	y2% = y1%
	xAlt% = x2%
	yAlt% = y2%
	ZeichneXORRechteck x1%, y1%, x2%, y2%
	DO
		dosIntEin.ax = &H3
		CALL INTERRUPT(&H33, dosIntEin, dosIntAus)
		x2% = dosIntAus.cx
		y2% = dosIntAus.dx
		IF x2% <> xAlt% OR y2% <> yAlt% THEN
			ZeichneXORRechteck x1%, y1%, xAlt%, yAlt%
			ZeichneXORRechteck x1%, y1%, x2%, y2%
			xAlt% = x2%
			yAlt% = y2%
		END IF
		ta$ = INKEY$
		IF ta$ = CHR$(27) THEN
			drinbleib% = 0
		END IF
	LOOP WHILE (dosIntAus.bx AND 1) = 1 AND drinbleib%
	ZeichneXORRechteck x1%, y1%, x2%, y2%
	IF x2% < x1% THEN
		SWAP x1%, x2%
	END IF
	IF y2% < y1% THEN
		SWAP y1%, y2%
	END IF
	xMax! = xMin! + CSNG(x2% + 1) * fakt!
	xMin! = xMin! + CSNG(x1%) * fakt!
	yMax! = yMax! - CSNG(y1%) * fakt!
WEND

SCREEN 0
WIDTH 80, 25

SUB AddiereKomplex (a AS Komplex, b AS Komplex, s AS Komplex)
	s.r = a.r + b.r
	s.i = a.i + b.i
END SUB

FUNCTION KomplexABS2! (a AS Komplex)
	KomplexABS2! = a.r * a.r + a.i * a.i
END FUNCTION

SUB Multipliziere (a AS Komplex, b AS Komplex, p AS Komplex)
	p.r = a.r * b.r - a.i * b.i
	p.i = a.r * b.i + a.i * b.r
END SUB

SUB ZeichneFadenkreuz (x%, y%)
	xorRecht%(0) = 640
	xorRecht%(1) = 1
	PUT (0, y%), xorRecht%, XOR
	xorRecht%(0) = 1
	xorRecht%(1) = 480
	PUT (x%, 0), xorRecht%, XOR
END SUB

SUB ZeichneXORRechteck (x1%, y1%, x2%, y2%)
	IF x2% > x1% THEN
		xt1% = x1%
		xt2% = x2%
	ELSE
		xt1% = x2%
		xt2% = x1%
	END IF
	IF y2% > y1% THEN
		yt1% = y1%
		yt2% = y2%
	ELSE
		yt1% = y2%
		yt2% = y1%
	END IF
	IF xt2% - xt1% < 2 OR yt2% - yt1% < 2 THEN
		' Kleines Rechteck, welches zu deckender Linie degradiert ist
		xorRecht%(0) = xt2% - xt1% + 1
		xorRecht%(1) = yt2% - yt1% + 1
		PUT (xt1%, yt1%), xorRecht%, XOR
	ELSE
		' horizontale Linien
		xorRecht%(0) = xt2% - xt1%
		xorRecht%(1) = 1
		PUT (xt1%, yt1%), xorRecht%, XOR
		PUT (xt1% + 1, yt2%), xorRecht%, XOR
		' vertikale Linien
		xorRecht%(0) = 1
		xorRecht%(1) = yt2% - yt1%
		PUT (xt1%, yt1% + 1), xorRecht%
		PUT (xt2%, yt1%), xorRecht%
	END IF
END SUB

